{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Поддержка источника питания контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}


{$I uev3defines.inc}

unit rubiroBattery;


interface

uses
  uev3, SysUtils, uev3sysfs;

type

  { TEv3Battery }

  TEv3Battery=class(TEv3)
    private
     fvolt,fminvolt,fmaxvolt:TEv3Data;
     scale:double;
    public
      constructor create();
      destructor destroy; override;
      { возвращает напряжение в вольтах (вещественное значение)}
      function volt:variant;
      { возвращает уровень зарядки в процентах от 0 до 100 (вещественное значение)}
      function live:variant;
  end;

  var ev3Battery:TEv3Battery;

implementation
 uses variants,uev3func;

constructor TEv3Battery.create;
 var bfs:string='/sys/class/power_supply';
    sa:TAAString=nil;
    fn:string;
begin
  inherited create;
  findDirs(bfs,sa); bfs:=sa[0];
  fvolt:=TEv3Data.Create(bfs+'/voltage_now');
  if fileExists(bfs+'/voltage_min_design') then
   fminvolt:=TEv3Data.Create(bfs+'/voltage_min_design')
  else begin
   fn:=gettempdir+'voltage_min_design';
   TEv3Data.WriteStrToFile(fn,fvolt.sData);
   fminvolt:=TEv3Data.Create(fn);
  end;
  if fileExists(bfs+'/voltage_max_design') then
   fmaxvolt:=TEv3Data.Create(bfs+'/voltage_max_design')
  else begin
   fn:=gettempdir+'voltage_max_design';
   TEv3Data.WriteStrToFile(fn,fvolt.sData);
   fminvolt:=TEv3Data.Create(fn);
  end;
  scale:=1;
  // коррекция ошибок драйвера
  if (double(fminvolt.iData)/double(fvolt.iData) > 3) then scale:=10;
  if (double(fvolt.iData)/double(fmaxvolt.iData) > 3) then scale:=0.1;
end;

destructor TEv3Battery.destroy;
begin
  fvolt.free;
  fminvolt.free;
  fmaxvolt.free;
  inherited destroy;
end;

function TEv3Battery.volt: variant;
begin
 exit(fvolt.iData/1000000.0);
end;

function TEv3Battery.live: variant;
 var min,max,cur:double;
begin
 min:=fminvolt.idata;
 max:=fmaxvolt.idata;
 cur:=fvolt.idata*scale;
 result:=100.0*(cur-min)/(max-min);
 if result<0 then result:=0.0;
 if result>100 then result:=100.0;
end;

procedure init; begin
  ev3Battery:=TEv3Battery.Create;
end;
procedure done; begin
  ev3Battery.free;
end;

initialization
  PushInit(@init);
  PushDone(@done);
end.

