{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Тела функций преобразований типов 
    для модуля uev3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

// -------------------------------------------
function isInt(arg: TVarRec): boolean;
begin
 if arg.vtype in [vtInteger,vtInt64,vtQWord] then exit(true);
 if (arg.vtype=vtVariant) then exit(isInt(Arg.VVariant^));
 result:=false;
end;

function isInt(arg: variant): boolean;
begin
 result:=VarIsOrdinal(Arg);
end;

function isReal(arg: TVarRec): boolean;
begin
 if arg.vtype=vtextended then exit(true);
 if (arg.vtype=vtVariant) then exit(isReal(Arg.VVariant^));
 result:=false;
end;

function isReal(arg: variant): boolean;
begin
 result:=VarIsFloat(Arg);
end;

function isStr(arg: TVarRec): boolean;
begin
 if arg.vtype in [vtChar,vtString,vtPChar,vtAnsiString] then exit(true);
 if (arg.vtype=vtVariant) then exit(isStr(Arg.VVariant^));
 result:=false;
end;

function isStr(arg: variant): boolean;
begin
  result:=VarIsStr(arg);
end;

function isBool(arg: TVarRec): boolean;
begin
 if arg.vtype=vtBoolean then exit(true);
 if (arg.vtype=vtVariant) then exit(isBool(Arg.VVariant^));
 result:=false;
end;

function isBool(arg: variant): boolean;
begin
 result:=VarIsBool(Arg);
end;

function isObject(arg: TVarRec): boolean;
begin
 if arg.vtype=vtObject then exit(true);
 result:=false;
end;

function isObject(arg: variant): boolean;
begin
  result:=false;
end;

function isClass(arg: TVarRec): boolean;
begin
 if arg.vtype=vtClass then exit(true);
 result:=false;
end;

function isClass(arg: variant): boolean;
begin
  result:=false;
end;

function isPointer(arg: TVarRec): boolean;
begin
 result:=arg.vtype=vtPointer;
end;

function isPointer(arg: variant): boolean;
begin
  result:=false;
end;

function extractString(arg: variant; var s:string):boolean;
 begin
  s:='';
  if varIsStr(Arg) then s:=varToStr(Arg) else exit(false);
  result:=true;
 end;

function extractString(arg: TVarRec; var s:string):boolean;
 begin
  s:='';
  case arg.vtype of
   vtPChar       : s:=arg.vPChar;
   vtChar        : s:=arg.vChar;
   vtWideChar    : s:=arg.vWideChar;
   vtString      : s:=arg.VString^;
   vtAnsiString  : s:=String(Arg.VAnsiString);
   vtWideString  : s:=String(Arg.VWideString);
   vtUnicodeString:s:=String(Arg.VUnicodeString);
   vtVariant      :exit(extractString(Arg.VVariant^,s));
   else exit(false);
  end;
  result:=true;
 end;

function extractInteger(arg: variant; var i:int64):boolean;
 begin
  i:=0;
  if VarIsNumeric(Arg) then i:=integer(Arg) else exit(false);
  result:=true;
 end;

function extractInteger(arg: TVarRec; var i:int64):boolean;
 begin
  i:=0;
  case arg.vtype of
   vtInteger     : i:=arg.VInteger;
   vtInt64       : i:=arg.VInt64^;
   vtQWord       : i:=arg.VQWord^;
   vtVariant      :exit(extractInteger(Arg.VVariant^,i));
   else exit(false);
  end;
  result:=true;
 end;

function stringToReal(s:string):double;
 var r:double; err:integer;
begin
 val(s,r,err);
 if err=0 then exit(r);
 result:=0.0;
 {
 s:=UTF8LowerCase(s);
 case s of
  '','false','no','ложь','нет': exit(0.0);
  else exit(1.0);
 end;
 }
end;

function stringToBoolean(s:string):boolean;
 var r:double; err:integer;
begin
 val(s,r,err);
 if err=0 then exit(r<>0);
 s:=UTF8LowerCase(s);
 case s of
  '','false','no','ложь','нет': exit(false);
  else exit(true);
 end;
end;


function stringToInteger(s:string):int64;
begin
 result:=round(stringToReal(s));
end;


//----------- toInt -----------------

function toInt(arg: TVarRec): int64;
 var s:string='';
begin
 if extractString(arg,s) then exit(toInt(s));
 if extractInteger(arg,result) then exit;
 case arg.vtype of
  vtextended    : exit(toInt(arg.VExtended^));
  vtBoolean     : exit(toInt(arg.VBoolean));
  vtObject      : exit(toInt(arg.vObject));
  vtClass       : exit(toInt(arg.vClass));
  vtVariant     : exit(toInt(Arg.VVariant^));
  vtCurrency    : exit(toInt(double(arg.VCurrency^)));
  vtPointer     : exit(toInt(Arg.VPointer));
  else exit(0);
 end;
end;

function toInt(arg: variant): int64;
 var s:string='';
begin
 if extractString(arg,s) then exit(toInt(s));
 if varIsNumeric(arg) then exit(toInt(int64(arg)));
end;

function toInt(arg: int64): int64;
begin
  result:=arg;
end;

function toInt(arg: double): int64;
begin
  result:=round(arg);
end;

function toInt(arg: string): int64;
begin
 result:=stringToInteger(arg);
end;

function toInt(arg: boolean): int64;
begin
 // ord(true) дает max(dword), поэтому - ветвлением
 if arg then exit(1) else exit(0);
end;

function toInt(arg: TObject): int64;
begin
 result:=ptrInt(toPointer(arg));
end;

function toInt(arg: TClass): int64;
begin
 result:=ord(assigned(arg));
end;

function toInt(arg: pointer): int64;
begin
  result:=int64(arg);
end;

//----------- toReal -----------------

function toReal(arg: TVarRec): double;
 var s:string='';i:int64=0;
begin
 if extractString(arg,s) then exit(toReal(s));
 if extractInteger(arg,i) then exit(i);
 case arg.vtype of
  vtextended    : exit(toReal(arg.VExtended^));
  vtBoolean     : exit(toReal(arg.VBoolean));
  vtObject      : exit(toReal(arg.vObject));
  vtClass       : exit(toReal(arg.vClass));
  vtVariant     : exit(toReal(Arg.VVariant^));
  vtCurrency    : exit(toReal(double(arg.VCurrency^)));
  vtPointer     : exit(toReal(Arg.VPointer));
  else exit(0);
 end;
end;

function toReal(arg: variant): double;
 var s:string='';
begin
 if extractString(arg,s) then exit(stringToReal(s));
 if varIsNumeric(arg) then exit(double(arg));
end;

function toReal(arg: int64): double;
begin
 result:=arg;
end;

function toReal(arg: double): double;
begin
  result:=double(arg);
end;

function toReal(arg: string): double;
var err:integer;
begin
 result:=stringToReal(arg);
end;

function toReal(arg: boolean): double;
begin
 result:=double(toInt(arg));
end;

function toReal(arg: TObject): double;
begin
 result:=double(toInt(arg));
end;

function toReal(arg: TClass): double;
begin
 result:=double(toInt(arg));
end;

function toReal(arg: pointer): double;
begin
 result:=double(toInt(arg));
end;

//----------- toSTR -----------------
function toStr(arg: TVarRec): string;
 var i:int64=0;
begin
 result:='';
 if extractString(arg,result) then exit;
 if extractInteger(arg,i) then exit(toStr(i));
 case arg.vtype of
  vtextended    : exit(toStr(arg.VExtended^));
  vtBoolean     : exit(toStr(arg.vBoolean));
  vtObject      : exit(toStr(arg.vObject));
  vtClass       : exit(toStr(arg.vClass));
  vtVariant     : exit(toStr(Arg.VVariant^));
  vtCurrency    : exit(toStr(double(arg.VCurrency^)));
  vtPointer     : exit(toStr(Arg.VPointer));
  else exit('');
 end;
end;

function toStr(arg: variant): string;
 var s:string='';
begin
 if extractString(arg,s) then exit(s);
 if varIsNumeric(arg) then exit(toStr(double(arg)));
end;

function toStr(arg: int64): string;
begin
  result:=intToStr(arg);
end;

function toStr(arg: double): string;
begin
 result:=formatFloat('#.######',arg);
end;

function toStr(arg: string): string;
begin
 result:=arg;
end;

function toStr(arg: boolean): string;
begin
 if arg then exit('TRUE') else exit('FALSE');
end;

function toStr(arg: TObject): string;
begin
 if assigned(arg) then exit(arg.ClassName) else exit('');
end;

function toStr(arg: TClass): string;
begin
 if assigned(arg) then exit(arg.ClassName) else exit('');
end;

function toStr(arg: pointer): string;
begin
 result:=toStr(toInt(arg));
end;

//------------ toBool --------------

function toBool(arg: TVarRec): boolean;
 var s:string=''; i:int64=0;
begin
 if extractString(arg,s) then exit(toBool(s));
 if extractInteger(arg,i) then exit(toBool(i));
 case arg.vtype of
  vtextended    : exit(toBool(arg.VExtended^));
  vtBoolean     : exit(toBool(arg.vBoolean));
  vtObject      : exit(toBool(arg.vObject));
  vtClass       : exit(toBool(arg.vClass));
  vtVariant     : exit(toBool(Arg.VVariant^));
  vtCurrency    : exit(toBool(double(arg.VCurrency^)));
  vtPointer     : exit(toBool(Arg.VPointer));
  else exit(false);
 end;
end;

function toBool(arg: variant): boolean;
 var s:string='';
begin
 if extractString(arg,s) then exit(toBool(s));
 if varIsNumeric(arg) then exit(toBool(int64(arg)));
end;

function toBool(arg: int64): boolean;
begin
  result:=boolean(arg);
end;

function toBool(arg: double): boolean;
begin
 result:=arg<>0.0;
end;

function toBool(arg: string): boolean;
begin
  result:=stringToBoolean(arg);
end;

function toBool(arg: boolean): boolean;
begin
 result:=arg;
end;

function toBool(arg: TObject): boolean;
begin
  result:=assigned(arg);
end;

function toBool(arg: TClass): boolean;
begin
 result:=assigned(arg);
end;

function toBool(arg: pointer): boolean;
begin
 result:=assigned(arg);
end;

// ---------- toObject ------------

function toObject(arg: TVarRec): TObject;
begin
  if arg.vtype=vtObject then exit(arg.vObject);
  result:=toObject(toPointer(arg));
end;

function toObject(arg: variant): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: int64): TObject;
begin
  result:=toObject(toPointer(arg));
end;

function toObject(arg: double): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: string): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: boolean): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: TObject): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: TClass): TObject;
begin
 result:=toObject(toPointer(arg));
end;

function toObject(arg: pointer): TObject;
begin
 if TObject(arg) is TObject then exit(TObject(arg) as TObject);
 result:=nil;
end;

// ------------ toClass -------------

function toClass(arg: TVarRec): TClass;
begin
 case arg.vtype of
  vtObject      : exit(arg.vObject.classType);
  vtClass       : exit(arg.VClass);
  else if toBool(arg) then exit(TObject) else exit(nil);
 end;
end;

function toClass(arg: variant): TClass;
begin
 result:=nil;
end;

function toClass(arg: int64): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: double): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: string): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: boolean): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: TObject): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: TClass): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

function toClass(arg: pointer): TClass;
begin
  if toBool(arg) then exit(TObject) else exit(nil);
end;

// ------------ toPointer -------------


function toPointer(arg: TVarRec): pointer;
begin
  case arg.vtype of
   vtObject      : exit(toPointer(arg.vObject));
   vtPointer     : exit(arg.VPointer)
   else exit(pointer(toInt(arg)));
  end;
end;

function toPointer(arg: variant): pointer;
begin
 result:=pointer(toInt(arg));
end;

function toPointer(arg: int64): pointer;
begin
  result:=pointer(arg);
end;

function toPointer(arg: double): pointer;
begin
  result:=pointer(toInt(arg));
end;

function toPointer(arg: string): pointer;
begin
  result:=pointer(toInt(arg));
end;

function toPointer(arg: boolean): pointer;
begin
 result:=pointer(toInt(arg));
end;

function toPointer(arg: TObject): pointer;
begin
 result:=pointer(arg);
end;

function toPointer(arg: TClass): pointer;
begin
 result:=pointer(arg);
end;

function toPointer(arg: pointer): pointer;
begin
 result:=arg;
end;
